//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "SearchDlg.h"
#include "TransferWnd.h"
#include "OtherFunctions.h"
#include "ClientList.h"
#include "UploadQueue.h"
#include "DownloadQueue.h"
#include "emuledlg.h"
#include "MenuCmds.h"
#include "PartFile.h"
#include "CatDialog.h"
#include "InputBox.h"
#include "UserMsgs.h"
#include "SharedFileList.h"
#include "UpdownClient.h" // Pawcio: Mod Version
//>>> ProgressBars  
#include "Log.h"   
#include "./MiniMule/GetCpuUsage.h"  
#include "./MiniMule/SysInfo.h"  
#include ".\transferwnd.h"
//<<< ProgressBars

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif
// CTransferWnd dialog

IMPLEMENT_DYNAMIC(CTransferWnd, CDialog)

BEGIN_MESSAGE_MAP(CTransferWnd, CResizableDialog)
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_SYSCOLORCHANGE()
	ON_NOTIFY(LVN_HOTTRACK, IDC_UPLOADLIST, OnHoverUploadList)
	ON_NOTIFY(LVN_HOTTRACK, IDC_RESERVEDLIST, OnHoverUploadList)//Pawcio: BC
	ON_NOTIFY(LVN_HOTTRACK, IDC_QUEUELIST, OnHoverUploadList)
	ON_NOTIFY(LVN_HOTTRACK, IDC_DOWNLOADLIST, OnHoverDownloadList)
	ON_NOTIFY(LVN_HOTTRACK, IDC_CLIENTLIST , OnHoverUploadList)
	ON_NOTIFY(LVN_HOTTRACK, IDC_DOWNLOADCLIENTS, OnHoverUploadList) // Stormit: DTW
	ON_NOTIFY(TCN_SELCHANGE, IDC_DLTAB, OnTcnSelchangeDltab)
	ON_NOTIFY(NM_RCLICK, IDC_DLTAB, OnNMRclickDltab)
	ON_NOTIFY(LVN_BEGINDRAG, IDC_DOWNLOADLIST, OnLvnBegindrag)
	ON_NOTIFY(LVN_KEYDOWN, IDC_DOWNLOADLIST, OnLvnKeydownDownloadlist)
	ON_NOTIFY(UM_TABMOVED, IDC_DLTAB, OnTabMovement)
END_MESSAGE_MAP()

CTransferWnd::CTransferWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CTransferWnd::IDD, pParent)
{
	m_uWnd2 = wnd2Uploading;
	//m_dwShowListIDC = 0;
	m_pLastMousePoint.x = -1;
	m_pLastMousePoint.y = -1;
	m_nLastCatTT = -1;
}

CTransferWnd::~CTransferWnd()
{
//>>> ProgressBars  
     if (m_hTimer)  
     {  
          ::KillTimer(NULL, m_hTimer);  
          m_hTimer = 0;  
     }  
//<<< ProgressBars
}

BOOL CTransferWnd::OnInitDialog()
{
	CResizableDialog::OnInitDialog();
	InitWindowStyles(this);

	uploadlistctrl.Init();
	reservedlistctrl.Init(); //Pawcio: BC
	downloadlistctrl.Init();
	queuelistctrl.Init();
	clientlistctrl.Init();
	downloadclientsctrl.Init();

	if (thePrefs.GetRestoreLastMainWndDlg())
		m_uWnd2 = (EWnd2)thePrefs.GetTransferWnd2();
	ShowWnd2(m_uWnd2);

	SetAllIcons();
    Localize();
	
	m_uplBtn.SetAlign(CButtonST::ST_ALIGN_HORIZ);
	m_uplBtn.SetFlat();
	m_uplBtn.DrawFlatFocus(TRUE);
	m_uplBtn.SetLeftAlign(true);

	AddAnchor(IDC_DOWNLOADLIST,TOP_LEFT,CSize(100, thePrefs.GetSplitterbarPosition() ));
	AddAnchor(IDC_UPLOADLIST,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_RESERVEDLIST,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);//Pawcio: BC
	AddAnchor(IDC_QUEUELIST,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_CLIENTLIST,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_DOWNLOADCLIENTS,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT); // Stormit: DTW
	AddAnchor(IDC_UPLOAD_ICO,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	//[ionix] Drop Menue Buttons
	AddAnchor(IDC_TRANSFER_DROP_FULLQ,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT); 
	AddAnchor(IDC_TRANSFER_DROP_NNS,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT); 
	AddAnchor(IDC_TRANSFER_DROP_TOO_MANY,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_TRANSFER_DROP_HIGH_QUEUE_SOURCES,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	//[ionix] Drop Menue Buttons
	// Pawcio: CQV
	AddAnchor(IDC_UP_QUEUE,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_DOWN_QUEUE,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_WAIT_QUEUE,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_CLIENT_QUEUE,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	// <--- Pawcio: CQV
	AddAnchor(IDC_QUEUECOUNT,BOTTOM_LEFT);
	AddAnchor(IDC_TSTATIC1,BOTTOM_LEFT);
	AddAnchor(IDC_QUEUE_REFRESH_BUTTON, BOTTOM_RIGHT);
	AddAnchor(IDC_DLTAB,CSize(50,0) ,TOP_RIGHT);

	// splitting functionality
	CRect rc,rcSpl,rcDown;

	GetWindowRect(rc);
	ScreenToClient(rc);

	rcSpl=rc; rcSpl.top=rc.bottom-100 ; rcSpl.bottom=rcSpl.top+5;rcSpl.left=55;
	m_wndSplitter.Create(WS_CHILD | WS_VISIBLE, rcSpl, this, IDC_SPLITTER);
	SetInitLayout();
	
	//cats
	rightclickindex=-1;

	downloadlistactive=true;
	m_bIsDragging=false;

	// show & cat-tabs
/*
	_stprintf(thePrefs.GetCategory(0)->title, _T("%s"), GetCatTitle(thePrefs.GetCategory(0)->filter));
	_stprintf(thePrefs.GetCategory(0)->incomingpath, _T("%s"), thePrefs.GetIncomingDir());
	thePrefs.GetCategory(0)->care4all=true;

	for (int ix=0;ix<thePrefs.GetCatCount();ix++)
		m_dlTab.InsertItem(ix,thePrefs.GetCategory(ix)->title );
*/
	// [ionix] - Modified Categories by khaos::categorymod+
  	for (int ix=0; ix < thePrefs.GetCatCount(); ix++)
	{
		//thePrefs.GetCategory(ix)->viewfilters.nFromCats = 0;
		m_dlTab.InsertItem(ix,thePrefs.GetCategory(ix)->title );
	}
	UpdateCatTabTitles();
	// [ionix] - Modified Categories by khaos::categorymod-
	// create tooltip control for download categories
	m_tooltipCats.Create(this, TTS_NOPREFIX);
	m_dlTab.SetToolTips(&m_tooltipCats);
	UpdateCatTabTitles();
	UpdateTabToolTips();
	m_tooltipCats.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX); // recognize \n chars!
	m_tooltipCats.SetDelayTime(TTDT_AUTOPOP, 20000);
	m_tooltipCats.SetDelayTime(TTDT_INITIAL, thePrefs.GetToolTipDelay()*1000);
	m_tooltipCats.Activate(TRUE);

	UpdateListCount(m_uWnd2);
	VerifyCatTabSize();

//>>> ProgressBars  
	m_pCPUBar.SetBkColor(GetSysColor(COLOR_WINDOW));  
	m_pRAMBar.SetBkColor(GetSysColor(COLOR_WINDOW));  

	//Show current percentage  
	m_pCPUBar.SetShowPercent();  
	m_pRAMBar.SetShowPercent();

	//Rubber are nicer...  
	m_pCPUBar.SetRubberBar(true);  
	m_pRAMBar.SetRubberBar(true);  

	//Green to red       
	m_pCPUBar.SetGradientColors(RGB(0, 255, 0), RGB(255, 0, 0));  
	m_pRAMBar.SetGradientColors(RGB(0, 255, 0), RGB(255, 0, 0));

	//Set ranges  
	m_pCPUBar.SetRange(0, 100);  
	m_pRAMBar.SetRange(0, theApp.sysinfo->GetTotalPhys()/1048576.0F);  

	m_hTimer = 0;
	if(thePrefs.UseProgressBars())
		ShowProgressBars();
	else
		HideProgressBars();
//<<< ProgressBars

	return true;
}

void CTransferWnd::ShowQueueCount(uint32 number)
{
	TCHAR buffer[100];
	_stprintf(buffer,_T("%u (%u ") + GetResString(IDS_BANNED).MakeLower() + _T(")"), number,theApp.clientlist->GetBannedCount() );
	GetDlgItem(IDC_QUEUECOUNT)->SetWindowText(buffer);
}

void CTransferWnd::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_UPLOADLIST, uploadlistctrl);
	DDX_Control(pDX, IDC_RESERVEDLIST, reservedlistctrl); //Pawcio: BC
	DDX_Control(pDX, IDC_DOWNLOADLIST, downloadlistctrl);
	DDX_Control(pDX, IDC_QUEUELIST, queuelistctrl);
	DDX_Control(pDX, IDC_CLIENTLIST, clientlistctrl);
	DDX_Control(pDX, IDC_DOWNLOADCLIENTS, downloadclientsctrl); // Stormit: DTW
	DDX_Control(pDX, IDC_UPLOAD_ICO, m_uplBtn);
	//[ionix] Drop Menue Buttons
	DDX_Control(pDX,IDC_TRANSFER_DROP_FULLQ, m_DropAllFullQBtn);
	DDX_Control(pDX,IDC_TRANSFER_DROP_NNS, m_DropAllNNSBtn);
	DDX_Control(pDX,IDC_TRANSFER_DROP_TOO_MANY, m_DropTooManyBtn);
	DDX_Control(pDX,IDC_TRANSFER_DROP_HIGH_QUEUE_SOURCES, m_DropAllHighQueueSourcesQBtn);
	//[ionix] Drop Menue Buttons
	// Pawcio: CQV
	DDX_Control(pDX, IDC_UP_QUEUE, m_up_q);
	DDX_Control(pDX, IDC_DOWN_QUEUE, m_down_q);
	DDX_Control(pDX, IDC_WAIT_QUEUE, m_wait_q);
	DDX_Control(pDX, IDC_CLIENT_QUEUE, m_client_q);
	// <--- Pawcio: CQV
	DDX_Control(pDX, IDC_DLTAB, m_dlTab);
//>>> ProgressBars  
     DDX_Control(pDX,IDC_CPUPROGRESS, m_pCPUBar);  
     DDX_Control(pDX,IDC_RAMPROGRESS, m_pRAMBar);  
//<<< ProgressBars   
}

void CTransferWnd::SetInitLayout() {
	CRect rcDown,rcSpl,rcW;

	GetWindowRect(rcW);
	ScreenToClient(rcW);

	LONG splitpos=(thePrefs.GetSplitterbarPosition()*rcW.Height())/100;

	GetDlgItem(IDC_DOWNLOADLIST)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.right=rcW.right-7;
	rcDown.bottom=splitpos-5;
	downloadlistctrl.MoveWindow(rcDown);
	
	int value = thePrefs.UseProgressBars()?15:0; // [ionix] - ProgressBars

	GetDlgItem(IDC_UPLOADLIST)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.right=rcW.right-7;
	rcDown.bottom=rcW.bottom-20-value; // [ionix]- ProgressBars - added -15
	rcDown.top=splitpos+20;
	uploadlistctrl.MoveWindow(rcDown);

	//Pawcio: BC
	GetDlgItem(IDC_RESERVEDLIST)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.right=rcW.right-7;
	rcDown.bottom=rcW.bottom-20-value; // [ionix]- ProgressBars - added -value
	rcDown.top=splitpos+20;
	reservedlistctrl.MoveWindow(rcDown);
	//Pawcio: BC

	// Stormit: DTW
	GetDlgItem(IDC_DOWNLOADCLIENTS)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.right=rcW.right-7;
	rcDown.bottom=rcW.bottom-20-value; // [ionix]- ProgressBars - added -value
	rcDown.top=splitpos+20;
	downloadclientsctrl.MoveWindow(rcDown);
	// <--- Stormit: DTW

	GetDlgItem(IDC_QUEUELIST)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.right=rcW.right-7;
	rcDown.bottom=rcW.bottom-20-value; // [ionix]- ProgressBars - added -value
	rcDown.top=splitpos+20;
	queuelistctrl.MoveWindow(rcDown);

	GetDlgItem(IDC_CLIENTLIST)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.right=rcW.right-7;
	rcDown.bottom=rcW.bottom-20-value; // [ionix]- ProgressBars - added -value
	rcDown.top=splitpos+20;
	clientlistctrl.MoveWindow(rcDown);

	if(!thePrefs.UseProgressBars())
	{
		RemoveAnchor(IDC_QUEUE_REFRESH_BUTTON);   
		RemoveAnchor(IDC_TSTATIC1);
		RemoveAnchor(IDC_QUEUECOUNT);

		// [ionix] - ProgressBars
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->GetWindowRect(rcDown);
		ScreenToClient(rcDown);
		rcDown.top=rcW.bottom-19/*-value*/;
		rcDown.bottom=rcW.bottom-3/*-value*/;
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->MoveWindow(rcDown);

		GetDlgItem(IDC_TSTATIC1)->GetWindowRect(rcDown);
		ScreenToClient(rcDown);
		rcDown.top=rcW.bottom-18/*-value*/;
		rcDown.bottom=rcW.bottom-5/*-value*/;
		GetDlgItem(IDC_TSTATIC1)->MoveWindow(rcDown);

		GetDlgItem(IDC_QUEUECOUNT)->GetWindowRect(rcDown);
		ScreenToClient(rcDown);
		rcDown.top=rcW.bottom-18/*-value;
		rcDown.bottom=rcW.bottom-5/*-value*/;
		GetDlgItem(IDC_QUEUECOUNT)->MoveWindow(rcDown);
		// [ionix] - ProgressBars

		AddAnchor(IDC_QUEUECOUNT,BOTTOM_LEFT);
		AddAnchor(IDC_TSTATIC1,BOTTOM_LEFT);
		AddAnchor(IDC_QUEUE_REFRESH_BUTTON, BOTTOM_RIGHT);
	}

	rcSpl=rcDown;
	rcSpl.top=rcDown.bottom+4;rcSpl.bottom=rcSpl.top+7;rcSpl.left=(rcDown.right/2)-50;rcSpl.right=rcSpl.left+100;
	m_wndSplitter.MoveWindow(rcSpl,true);

	DoResize(0);
}

void CTransferWnd::DoResize(int delta)
{
	CSplitterControl::ChangeHeight(&downloadlistctrl, delta);
	CSplitterControl::ChangeHeight(&uploadlistctrl, -delta, CW_BOTTOMALIGN);
	CSplitterControl::ChangeHeight(&reservedlistctrl, -delta, CW_BOTTOMALIGN); //Pawcio: BC
	CSplitterControl::ChangeHeight(&queuelistctrl, -delta, CW_BOTTOMALIGN);
	CSplitterControl::ChangeHeight(&clientlistctrl, -delta, CW_BOTTOMALIGN);
	CSplitterControl::ChangeHeight(&downloadclientsctrl, -delta, CW_BOTTOMALIGN); // Stormit: DTW
	UpdateSplitterRange();

	Invalidate();
	UpdateWindow();
}

// setting splitter range limits
void CTransferWnd::UpdateSplitterRange()
{
	CRect rcWnd;
	GetWindowRect(rcWnd);

	CRect rcDown;
	downloadlistctrl.GetWindowRect(rcDown);
	ScreenToClient(rcDown);

	CRect rcUp;
	downloadclientsctrl.GetWindowRect(rcUp);
	ScreenToClient(rcUp);

	thePrefs.SetSplitterbarPosition((rcDown.bottom * 100) / rcWnd.Height());

	RemoveAnchor(IDC_DOWNLOADLIST);
	RemoveAnchor(IDC_UPLOADLIST);
	RemoveAnchor(IDC_RESERVEDLIST);//Pawcio: BC
	RemoveAnchor(IDC_QUEUELIST);
	RemoveAnchor(IDC_CLIENTLIST);
	RemoveAnchor(IDC_DOWNLOADCLIENTS); // Stormit: DTW
	AddAnchor(IDC_DOWNLOADLIST,TOP_LEFT,CSize(100,thePrefs.GetSplitterbarPosition() ));
	AddAnchor(IDC_UPLOADLIST,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_RESERVEDLIST,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);// Pawcio: BC
	AddAnchor(IDC_QUEUELIST,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_CLIENTLIST,CSize(0,thePrefs.GetSplitterbarPosition()),BOTTOM_RIGHT);
	AddAnchor(IDC_DOWNLOADCLIENTS, CSize(0, thePrefs.GetSplitterbarPosition()), BOTTOM_RIGHT);

	m_wndSplitter.SetRange(rcDown.top+50 , rcUp.bottom-40);

}


LRESULT CTransferWnd::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch (message)
	{
		// arrange transferwindow layout
		case WM_PAINT:
			if (m_wndSplitter)
			{
				CRect rcDown,rcSpl,rcW;
				GetWindowRect(rcW);
				if (rcW.Height() > 0)
				{
					CRect rcDown;
					downloadlistctrl.GetWindowRect(rcDown);
					ScreenToClient(rcDown);

					// splitter paint update
					rcSpl=rcDown;
					rcSpl.top=rcDown.bottom+8;rcSpl.bottom=rcSpl.top+5;rcSpl.left=270;
					GetDlgItem(IDC_UPLOAD_ICO)->MoveWindow(10,rcSpl.top-4,170,18);
					GetDlgItem(IDC_UP_QUEUE)->MoveWindow(180,rcSpl.top-4,20,18); 
					GetDlgItem(IDC_DOWN_QUEUE)->MoveWindow(200,rcSpl.top-4,20,18); 
					GetDlgItem(IDC_WAIT_QUEUE)->MoveWindow(220,rcSpl.top-4,20,18); 
					GetDlgItem(IDC_CLIENT_QUEUE)->MoveWindow(240,rcSpl.top-4,20,18); 
					m_wndSplitter.MoveWindow(rcSpl,true);
					UpdateSplitterRange();
					
					//[ionix] Drop Menue Buttons
					const uint8 ci_LSD_INITIAL_X_PIXELS=122;
					const uint8 ci_LSD_SIZE_X_PIXELS=23;

					GetDlgItem(IDC_TRANSFER_DROP_FULLQ)->MoveWindow(ci_LSD_INITIAL_X_PIXELS,rcDown.top-20-8,ci_LSD_SIZE_X_PIXELS,18+10);
					m_wndSplitter.MoveWindow(rcSpl,true);
					UpdateSplitterRange();
					GetDlgItem(IDC_TRANSFER_DROP_NNS)->MoveWindow(ci_LSD_INITIAL_X_PIXELS+(ci_LSD_SIZE_X_PIXELS+1),rcDown.top-20-8,ci_LSD_SIZE_X_PIXELS,18+10);
					m_wndSplitter.MoveWindow(rcSpl,true);
					UpdateSplitterRange();
					GetDlgItem(IDC_TRANSFER_DROP_TOO_MANY)->MoveWindow(ci_LSD_INITIAL_X_PIXELS+(ci_LSD_SIZE_X_PIXELS+1)*2,rcDown.top-20-8,ci_LSD_SIZE_X_PIXELS,18+10);
					m_wndSplitter.MoveWindow(rcSpl,true);
					UpdateSplitterRange();
					GetDlgItem(IDC_TRANSFER_DROP_HIGH_QUEUE_SOURCES)->MoveWindow(ci_LSD_INITIAL_X_PIXELS+(ci_LSD_SIZE_X_PIXELS+1)*3,rcDown.top-20-8,ci_LSD_SIZE_X_PIXELS,18+10);
					m_wndSplitter.MoveWindow(rcSpl,true);
					UpdateSplitterRange();
					//[ionix] Drop Menue Buttons					
				}
			}
			break;
		case WM_NOTIFY:
			if (wParam == IDC_SPLITTER)
			{	
				SPC_NMHDR* pHdr = (SPC_NMHDR*) lParam;
				DoResize(pHdr->delta);
			}
			break;
		case WM_WINDOWPOSCHANGED : 
			if (m_wndSplitter)
			{
				CRect rcWnd;
				GetWindowRect(rcWnd);
				if (rcWnd.Height() > 0)
					Invalidate();
			}
			break;
	}

	return CResizableDialog::DefWindowProc(message, wParam, lParam);
}

// CTransferWnd message handlers
BOOL CTransferWnd::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message== WM_LBUTTONDBLCLK && pMsg->hwnd == m_dlTab.m_hWnd) {
		OnDblclickDltab();
		return TRUE;
	}

	if (pMsg->message==WM_MOUSEMOVE) {
		POINT point;
		::GetCursorPos(&point);
		if (point.x!=m_pLastMousePoint.x || point.y!=m_pLastMousePoint.y) {
			m_pLastMousePoint=point;
			// handle tooltip updating, when mouse is moved from one item to another
			CPoint pt(point);
			m_nDropIndex=GetTabUnderMouse(&pt);
			if (m_nDropIndex!=m_nLastCatTT) {
				m_nLastCatTT=m_nDropIndex;
			    if (m_nDropIndex!=-1)
				    UpdateTabToolTips(m_nDropIndex);
			    //m_tooltipCats.Update();
			}
		}
	}

	if (pMsg->message == WM_MBUTTONUP)
	{
		if (downloadlistactive)
			downloadlistctrl.ShowSelectedFileDetails();
		else
		{
			switch (m_uWnd2)
			{
				case wnd2OnQueue:
					queuelistctrl.ShowSelectedUserDetails();
					break;
				case wnd2Uploading:
					uploadlistctrl.ShowSelectedUserDetails();
					break;
				case wnd2Clients:
					clientlistctrl.ShowSelectedUserDetails();
					break;
				case wnd2Downloading:
					ASSERT(0);
					break;
				case wnd2OnReserve: //Pawcio: BC
					reservedlistctrl.ShowSelectedUserDetails();
					break;
				default:
					ASSERT(0);
			}
		}
		return TRUE;
	}

	return CResizableDialog::PreTranslateMessage(pMsg);
}

int CTransferWnd::GetItemUnderMouse(CListCtrl* ctrl)
{
	CPoint pt;
	::GetCursorPos(&pt);
	ctrl->ScreenToClient(&pt);
	LVHITTESTINFO hit, subhit;
	hit.pt = pt;
	subhit.pt = pt;
	ctrl->SubItemHitTest(&subhit);
	int sel = ctrl->HitTest(&hit);
	if (sel != LB_ERR && (hit.flags & LVHT_ONITEM))
	{
		if (subhit.iSubItem == 0)
			return sel;
	}
	return LB_ERR;
}

/*
void CTransferWnd::UpdateFilesCount(int iCount)
{
	if (m_dwShowListIDC == IDC_DOWNLOADLIST || m_dwShowListIDC == IDC_DOWNLOADLIST + IDC_UPLOADLIST)
	{
		CString strBuffer;
		strBuffer.Format(_T("%s (%u)"), GetResString(IDS_TW_DOWNLOADS), iCount);
		m_btnWnd1.SetWindowText(strBuffer);
	}
}
*/

void CTransferWnd::UpdateListCount(EWnd2 listindex, int iCount /*=-1*/)
{
	//switch (m_dwShowListIDC) //???
	//{
	//	case IDC_DOWNLOADLIST + IDC_UPLOADLIST: {
			if (m_uWnd2 != listindex)
				return;
			CString strBuffer;
			switch (m_uWnd2)
			{
				case wnd2Uploading: {
					uint32 itemCount = iCount == -1 ? uploadlistctrl.GetItemCount() : iCount;
					uint32 activeCount = theApp.uploadqueue->GetActiveUploadsCount();
					if (activeCount >= itemCount)
						strBuffer.Format(_T(" (%i+%i)"), itemCount, reservedlistctrl.GetItemCount()); // Pawcio: BC
					else
						strBuffer.Format(_T(" (%i/%i+%i)"), activeCount, itemCount, reservedlistctrl.GetItemCount()); // Pawcio: BC
					m_uplBtn.SetWindowText(GetResString(IDS_UPLOADING) + strBuffer);
					break;
				}
				case wnd2OnQueue:
					strBuffer.Format(_T(" (%i)"), iCount == -1 ? queuelistctrl.GetItemCount() : iCount);
					m_uplBtn.SetWindowText(GetResString(IDS_ONQUEUE) + strBuffer);
					break;
				case wnd2Clients:
					strBuffer.Format(_T(" (%i)"), iCount == -1 ? clientlistctrl.GetItemCount() : iCount);
					m_uplBtn.SetWindowText(GetResString(IDS_CLIENTLIST) + strBuffer);
					break;
				case wnd2Downloading:
					strBuffer.Format(_T(" (%i)"), iCount == -1 ? downloadclientsctrl.GetItemCount() : iCount);
					m_uplBtn.SetWindowText(GetResString(IDS_DOWNLOADING) + strBuffer);
					break;
				case wnd2OnReserve:
					strBuffer.Format(_T(" (%i)"), iCount == -1 ? reservedlistctrl.GetItemCount() : iCount);
					m_uplBtn.SetWindowText(GetResString(IDS_TW_RESERVE) + strBuffer);
					break;
				default:
					ASSERT(0);
			}
		//	break;
		//}
/*
		case IDC_DOWNLOADLIST:
			break;

		case IDC_UPLOADLIST:
			if (listindex == wnd2Uploading)
			{
				CString strBuffer;
				uint32 itemCount = iCount == -1 ? uploadlistctrl.GetItemCount() : iCount;
				uint32 activeCount = theApp.uploadqueue->GetActiveUploadsCount();
				if (activeCount >= itemCount)
					strBuffer.Format(_T(" (%i)"), itemCount);
				else
					strBuffer.Format(_T(" (%i/%i)"), activeCount, itemCount);
				GetDlgItem(IDC_UPLOAD_ICO)->SetWindowText(GetResString(IDS_UPLOADING) + strBuffer);
			}
			break;

		case IDC_QUEUELIST:
			if (listindex == wnd2OnQueue)
			{
				CString strBuffer;
				strBuffer.Format(_T(" (%i)"), iCount == -1 ? queuelistctrl.GetItemCount() : iCount);
				GetDlgItem(IDC_UPLOAD_ICO)->SetWindowText(GetResString(IDS_ONQUEUE) + strBuffer);
			}
			break;
		
		case IDC_CLIENTLIST:
			if (listindex == wnd2Clients)
			{
				CString strBuffer;
				strBuffer.Format(_T(" (%i)"), iCount == -1 ? clientlistctrl.GetItemCount() : iCount);
				GetDlgItem(IDC_UPLOAD_ICO)->SetWindowText(GetResString(IDS_CLIENTLIST) + strBuffer);
			}
			break;

		case IDC_DOWNLOADCLIENTS:
			if (listindex == wnd2Downloading)
			{
				CString strBuffer;
				strBuffer.Format(_T(" (%i)"), iCount == -1 ? downloadclientsctrl.GetItemCount() : iCount);
				GetDlgItem(IDC_UPLOAD_ICO)->SetWindowText(GetResString(IDS_DOWNLOADING) + strBuffer);
			}
			break;

// [ionix] - Pawcio BC
		case IDC_RESERVEDLIST:
			if (listindex == wnd2OnReserve)
			{
				CString strBuffer;
				strBuffer.Format(_T(" (%i)"), iCount == -1 ? reservedlistctrl.GetItemCount() : iCount);
				GetDlgItem(IDC_UPLOAD_ICO)->SetWindowText(GetResString(IDS_TW_RESERVE) + strBuffer);
			}
			break;
// [ionix] - Pawcio BC
		default:
			//ASSERT(0);
			;
	}
*/
}

void CTransferWnd::SwitchUploadList()
{
	if (m_uWnd2 == wnd2Uploading)
	{
		SetWnd2(wnd2OnReserve);
		if (thePrefs.IsQueueListDisabled()){
			SwitchUploadList();
			return;
		}
		queuelistctrl.Hide();
		uploadlistctrl.Hide();
		clientlistctrl.Hide();
		downloadclientsctrl.Hide();
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_HIDE);
		reservedlistctrl.Visable();
		m_uplBtn.SetWindowText(GetResString(IDS_TW_RESERVE));
	}
	else if (m_uWnd2 == wnd2OnQueue)
	{
		SetWnd2(wnd2Clients);
		if (thePrefs.IsKnownClientListDisabled()){
			SwitchUploadList();
			return;
		}
		uploadlistctrl.Hide();
		queuelistctrl.Hide();
		reservedlistctrl.Hide();//Pawcio: BC
		downloadclientsctrl.Hide();
		clientlistctrl.Visable();
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_HIDE);
		m_uplBtn.SetWindowText(GetResString(IDS_CLIENTLIST));
	}
	else if (m_uWnd2 == wnd2Clients)
	{
		SetWnd2(wnd2Downloading);
		queuelistctrl.Hide();
		clientlistctrl.Hide();
		uploadlistctrl.Hide();
		reservedlistctrl.Hide();//Pawcio: BC
		downloadclientsctrl.Visible();
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_HIDE);
		m_uplBtn.SetWindowText(GetResString(IDS_DOWNLOADING));
	}
	else if ( m_uWnd2 == wnd2OnReserve ){//Pawcio: BC
		SetWnd2(wnd2OnQueue);	// Stormit: DTW from 2 to 5 - ionix: changed back	
		uploadlistctrl.Hide();
		clientlistctrl.Hide();
		reservedlistctrl.Hide(); //Pawcio: BC
		downloadclientsctrl.Hide();
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_SHOW); // Stormit: DTW
		queuelistctrl.Visable();
		m_uplBtn.SetWindowText(GetResString(IDS_ONQUEUE));
	}
	else
	{
		queuelistctrl.Hide();
		clientlistctrl.Hide();
		downloadclientsctrl.Hide();
		reservedlistctrl.Hide(); // Pawcio: BC
		uploadlistctrl.Visable();
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_HIDE);
		SetWnd2(wnd2Uploading);
		m_uplBtn.SetWindowText(GetResString(IDS_UPLOADING));
	}
	UpdateListCount(m_uWnd2);
	SetWnd2Icon();
}

void CTransferWnd::ShowWnd2(EWnd2 uWnd2)
{
	if (uWnd2 == wnd2OnQueue && !thePrefs.IsQueueListDisabled())
	{
		uploadlistctrl.Hide();
		clientlistctrl.Hide();
		reservedlistctrl.Hide();//Pawcio: BC
		downloadclientsctrl.Hide();
		queuelistctrl.Visable();
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_SHOW);
		m_uplBtn.SetWindowText(GetResString(IDS_ONQUEUE));
		SetWnd2(uWnd2);
	}
	else if (uWnd2 == wnd2Clients && !thePrefs.IsKnownClientListDisabled())
	{
		uploadlistctrl.Hide();
		queuelistctrl.Hide();
		reservedlistctrl.Hide();//Pawcio: BC
		downloadclientsctrl.Hide(); // Stormit: DTW
		clientlistctrl.Visable();
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_HIDE);
		m_uplBtn.SetWindowText(GetResString(IDS_CLIENTLIST));
		SetWnd2(uWnd2);
	}
	else if (uWnd2 == wnd2OnReserve)
	{
		queuelistctrl.Hide();
		clientlistctrl.Hide();
		uploadlistctrl.Hide();
		downloadclientsctrl.Hide(); // Stormit: DTW
		reservedlistctrl.Visable(); // Pawcio: BC
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_HIDE);
		m_uplBtn.SetWindowText(GetResString(IDS_TW_RESERVE));
		SetWnd2(uWnd2);
	}
	// Stormit: DTW
	else if (uWnd2 == wnd2Downloading)
	{
		queuelistctrl.Hide();
		clientlistctrl.Hide();
		uploadlistctrl.Hide();
		reservedlistctrl.Hide(); // Pawcio: BC
		downloadclientsctrl.Visible(); // Stormit: DTW
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_HIDE);
		m_uplBtn.SetWindowText(GetResString(IDS_DOWNLOADING));
		SetWnd2(uWnd2);
	}
	// <--- Stormit: DTW
	else
	{
		queuelistctrl.Hide();
		clientlistctrl.Hide();
		reservedlistctrl.Hide(); // Pawcio: BC
		downloadclientsctrl.Hide(); // Stormit: DTW
		uploadlistctrl.Visable();
		GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->ShowWindow(SW_HIDE);
		m_uplBtn.SetWindowText(GetResString(IDS_UPLOADING));
		SetWnd2(uWnd2);
	}
	UpdateListCount(uWnd2); // Stormit: DTW
	SetWnd2Icon();
}

void CTransferWnd::SetWnd2(EWnd2 uWnd2)
{
	m_uWnd2 = uWnd2;
	thePrefs.SetTransferWnd2(m_uWnd2);
}

void CTransferWnd::OnSysColorChange()
{
	CResizableDialog::OnSysColorChange();
	SetAllIcons();
}

void CTransferWnd::SetAllIcons()
{
	if (icon_download)
		VERIFY( DestroyIcon(icon_download) );
	icon_download = theApp.LoadIcon(_T("Download"), 16, 16);
	((CStatic*)GetDlgItem(IDC_DOWNLOAD_ICO))->SetIcon(icon_download);
	//[ionix] Drop Menue Buttons start
	// 1
	m_DropAllFullQBtn.SetIcon(_T("LSD_BUT_FULLQ"));
	m_DropAllFullQBtn.SetAlign(CButtonST::ST_ALIGN_HORIZ);
	m_DropAllFullQBtn.SetLeftAlign(true);
	// 2
	m_DropAllNNSBtn.SetIcon(_T("LSD_BUT_NNS"));
	m_DropAllNNSBtn.SetAlign(CButtonST::ST_ALIGN_HORIZ);
	m_DropAllNNSBtn.SetLeftAlign(true);
	// 3
	m_DropTooManyBtn.SetIcon(_T("LSD_BUT_TM"));
	m_DropTooManyBtn.SetAlign(CButtonST::ST_ALIGN_HORIZ);
	m_DropTooManyBtn.SetLeftAlign(true);
	// 4
	m_DropAllHighQueueSourcesQBtn.SetIcon(_T("LSD_BUT_HIGH_QUEUE_SOURCES"));
	m_DropAllHighQueueSourcesQBtn.SetAlign(CButtonST::ST_ALIGN_HORIZ);
	m_DropAllHighQueueSourcesQBtn.SetLeftAlign(true);
	//[ionix] Drop Menue Buttons end
	// Pawcio: CQV
	m_up_q.SetIcon(_T("Upload"));
	m_down_q.SetIcon(_T("Download"));
	m_wait_q.SetIcon(_T("ClientsOnQueue"));
	m_client_q.SetIcon(_T("ClientsKnown"));
	// <--- Pawcio: CQV
	SetWnd2Icon();
}

void CTransferWnd::SetWnd2Icon()
{
	if (m_uWnd2 == wnd2OnQueue)
		m_uplBtn.SetIcon(_T("ClientsOnQueue"));
	else if (m_uWnd2 == wnd2Uploading || m_uWnd2 == wnd2OnReserve)
		m_uplBtn.SetIcon(_T("Upload"));
	else if (m_uWnd2 == wnd2Clients)
		m_uplBtn.SetIcon(_T("ClientsKnown"));
	// Stormit: DTW
	else if (m_uWnd2 == wnd2Downloading)
		m_uplBtn.SetIcon(_T("Download"));
	// <--- Stormit: DTW
	else
		ASSERT(0);
}

void CTransferWnd::Localize()
{
	GetDlgItem(IDC_DOWNLOAD_TEXT)->SetWindowText(GetResString(IDS_DOWNLOADING));
	GetDlgItem(IDC_UPLOAD_ICO)->SetWindowText(GetResString(IDS_UPLOADING));
	GetDlgItem(IDC_TSTATIC1)->SetWindowText(GetResString(IDS_ONQUEUE));
	GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->SetWindowText(GetResString(IDS_SV_UPDATE));

	// [ionix] Localize Tooltips Buttons - Drop Menue
	m_DropAllFullQBtn.SetTooltipText(GetResString(IDS_TRANSFER_DROP_FULLQ));
	m_DropAllNNSBtn.SetTooltipText(GetResString(IDS_TRANSFER_DROP_NNS));
	m_DropTooManyBtn.SetTooltipText(GetResString(IDS_TRANSFER_DROP_TOO_MANY));
	m_DropAllHighQueueSourcesQBtn.SetTooltipText(GetResString(IDS_TRANSFER_DROP_HIGH_QUEUE_SOURCES));
	//LSD Localize End

	uploadlistctrl.Localize();
	reservedlistctrl.Localize();// Pawcio: BC
	downloadclientsctrl.Localize(); // Stormit: DTW

	queuelistctrl.Localize();
	downloadlistctrl.Localize();
	clientlistctrl.Localize();

	UpdateListCount(m_uWnd2);
}

void CTransferWnd::OnBnClickedQueueRefreshButton()
{
	CUpDownClient* update = theApp.uploadqueue->GetNextClient(NULL);

	while( update ){
		theApp.emuledlg->transferwnd->queuelistctrl.RefreshClient( update);
		update = theApp.uploadqueue->GetNextClient(update);
	}
}

void CTransferWnd::OnHoverUploadList(NMHDR *pNMHDR, LRESULT *pResult)
{
	downloadlistactive=false;
	*pResult = 0;
}

void CTransferWnd::OnHoverDownloadList(NMHDR *pNMHDR, LRESULT *pResult)
{
	downloadlistactive=true;
	*pResult = 0;
}

void CTransferWnd::OnTcnSelchangeDltab(NMHDR *pNMHDR, LRESULT *pResult)
{
	downloadlistctrl.ChangeCategory(m_dlTab.GetCurSel());
	*pResult = 0;
}

// Ornis' download categories
void CTransferWnd::OnNMRclickDltab(NMHDR *pNMHDR, LRESULT *pResult)
{
	UINT flag;
	CTitleMenu menu;
	POINT point;
	::GetCursorPos(&point);

	CPoint pt(point);
	rightclickindex=GetTabUnderMouse(&pt);

	if (rightclickindex==-1)
		return;

	CMenu m_CatMenu;
	m_CatMenu.CreateMenu();

	CMenu m_PrioMenu;
	m_PrioMenu.CreateMenu();

// ZZ:DownloadManager -->
    Category_Struct* category_Struct = thePrefs.GetCategory(rightclickindex);

	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
    m_PrioMenu.CheckMenuItem(MP_PRIOLOW, category_Struct && category_Struct->prio == PR_LOW ? MF_CHECKED : MF_UNCHECKED);

	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
    m_PrioMenu.CheckMenuItem(MP_PRIONORMAL, category_Struct && category_Struct->prio != PR_LOW && category_Struct->prio != PR_HIGH ? MF_CHECKED : MF_UNCHECKED);

	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));
    m_PrioMenu.CheckMenuItem(MP_PRIOHIGH, category_Struct && category_Struct->prio == PR_HIGH ? MF_CHECKED : MF_UNCHECKED);

    //m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOAUTO, GetResString(IDS_PRIOAUTO));
// <-- ZZ:DownloadManager

	menu.CreatePopupMenu();
        // [ionix] - Modified Categories by khaos::categorymod+
	Category_Struct* curCat = thePrefs.GetCategory(rightclickindex);
	if (rightclickindex)
		menu.AddMenuTitle(GetResString(IDS_CAT)+_T(" (")+curCat->title+_T(")") ,true );
	else
		menu.AddMenuTitle(GetResString(IDS_CAT),true);

	m_isetcatmenu=rightclickindex;
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0,GetResString(IDS_ALL) );

        // [ionix] - Modified Categories
	m_CatMenu.AppendMenu((!curCat->viewfilters.care4all && rightclickindex ) ? MF_GRAYED:MF_STRING,MP_CAT_SET0+1,GetResString(IDS_ALLOTHERS) );

	// selector for regular expression view filter
	if (rightclickindex) {
		if (thePrefs.IsExtControlsEnabled())
		{
			m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+2, GetResString(IDS_REGEXPRESSION) );
                        // [ionix] - Modified Categories
			m_CatMenu.CheckMenuItem(MP_CAT_SET0+2, (curCat->viewfilters.nFromCats == 2) ? MF_CHECKED : MF_UNCHECKED);
		}

		if (thePrefs.IsExtControlsEnabled() )
		{
			m_CatMenu.AppendMenu(MF_STRING | MF_BYCOMMAND,MP_CAT_SET0+3,GetResString(IDS_CARE4ALL) );
                        // [ionix] - Modified Categories
			m_CatMenu.CheckMenuItem(MP_CAT_SET0+3, (curCat->viewfilters.care4all) ? MF_CHECKED : MF_UNCHECKED);
		}
	}

	m_CatMenu.AppendMenu(MF_SEPARATOR);
        // [ionix] - Modified Categories: change of the numbers
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+4,GetResString(IDS_COMPLETE) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+5,GetResString(IDS_COMPLETING) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+6,GetResString(IDS_DOWNLOADING) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+7,GetResString(IDS_WAITING) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+8,GetResString(IDS_PAUSED) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+9,GetResString(IDS_STOPPED) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+10,GetResString(IDS_HASHING) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+11,GetResString(IDS_ERRORLIKE) );
	m_CatMenu.AppendMenu(MF_SEPARATOR);
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+12,GetResString(IDS_VIDEO) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+13,GetResString(IDS_AUDIO) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+14,GetResString(IDS_SEARCH_ARC) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+15,GetResString(IDS_SEARCH_CDIMG) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+16,GetResString(IDS_SEARCH_DOC) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+17,GetResString(IDS_SEARCH_PICS) );
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+18,GetResString(IDS_SEARCH_PRG) );
	m_CatMenu.AppendMenu(MF_SEPARATOR);		
	m_CatMenu.AppendMenu(MF_STRING,MP_CAT_SET0+19,GetResString(IDS_CAT_SUSPENDFILTERS) );
        // [ionix] - Modified Categories: removed
/*
	if (thePrefs.IsExtControlsEnabled()) {
		m_CatMenu.AppendMenu(MF_SEPARATOR);
		m_CatMenu.AppendMenu( thePrefs.GetCatFilter(rightclickindex)>0?MF_STRING:MF_GRAYED,MP_CAT_SET0+19,GetResString(IDS_NEGATEFILTER) );
		if ( thePrefs.GetCatFilterNeg(rightclickindex))
			m_CatMenu.CheckMenuItem( MP_CAT_SET0+19 ,MF_CHECKED | MF_BYCOMMAND);
	}
*/	
	//m_CatMenu.CheckMenuItem( MP_CAT_SET0+thePrefs.GetCatFilter(rightclickindex) ,MF_CHECKED | MF_BYCOMMAND);

	// Check and enable the appropriate menu items in Select View Filter
        // [ionix] - Modified Categories by khaos::categorymod+
	m_CatMenu.CheckMenuItem(MP_CAT_SET0, (curCat->viewfilters.nFromCats == 0) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+1, (curCat->viewfilters.nFromCats == 1) ? MF_CHECKED : MF_UNCHECKED);
	
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+4, (curCat->viewfilters.bComplete) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+5, (curCat->viewfilters.bCompleting) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+6, (curCat->viewfilters.bTransferring) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+7, (curCat->viewfilters.bWaiting) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+8, (curCat->viewfilters.bPaused) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+9, (curCat->viewfilters.bStopped) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+10, (curCat->viewfilters.bHashing) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+11, (curCat->viewfilters.bErrorUnknown) ? MF_CHECKED : MF_UNCHECKED);

	m_CatMenu.CheckMenuItem(MP_CAT_SET0+12, (curCat->viewfilters.bVideo) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+13, (curCat->viewfilters.bAudio) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+14, (curCat->viewfilters.bArchives) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+15, (curCat->viewfilters.bCDImages) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+16, (curCat->viewfilters.bDoc) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+17, (curCat->viewfilters.bImages) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+18, (curCat->viewfilters.bProgram) ? MF_CHECKED : MF_UNCHECKED);
	m_CatMenu.CheckMenuItem(MP_CAT_SET0+19, (curCat->viewfilters.bSuspendFilters) ? MF_CHECKED : MF_UNCHECKED);
        // [ionix] - Modified Categories

	menu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_CatMenu.m_hMenu, GetResString(IDS_CHANGECATVIEW),_T("SEARCHPARAMS") );
		menu.AppendMenu(MF_SEPARATOR);

	menu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PrioMenu.m_hMenu, GetResString(IDS_PRIORITY), _T("FILEPRIORITY") );

	menu.AppendMenu(MF_STRING,MP_CANCEL,GetResString(IDS_MAIN_BTN_CANCEL),_T("DELETE") );
	menu.AppendMenu(MF_STRING,MP_STOP, GetResString(IDS_DL_STOP),_T("STOP"));
	menu.AppendMenu(MF_STRING,MP_PAUSE, GetResString(IDS_DL_PAUSE), _T("PAUSE"));
	menu.AppendMenu(MF_STRING,MP_RESUME, GetResString(IDS_DL_RESUME), _T("RESUME"));
	menu.AppendMenu(MF_STRING,MP_RESUMENEXT, GetResString(IDS_DL_RESUMENEXT), _T("RESUME"));
	
// ZZ:DownloadManager -->
    if(rightclickindex != 0 && thePrefs.IsExtControlsEnabled()) {
        menu.AppendMenu(MF_STRING,MP_DOWNLOAD_ALPHABETICAL, GetResString(IDS_DOWNLOAD_ALPHABETICAL));	
        menu.CheckMenuItem(MP_DOWNLOAD_ALPHABETICAL, category_Struct && category_Struct->downloadInAlphabeticalOrder ? MF_CHECKED : MF_UNCHECKED);
    }
// <-- ZZ:DownloadManager

	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(MF_STRING,MP_HM_OPENINC, GetResString(IDS_OPENINC), _T("FOLDERS") );

	flag=(rightclickindex==0) ? MF_GRAYED:MF_STRING;
	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(MF_STRING,MP_CAT_ADD,GetResString(IDS_CAT_ADD));
	menu.AppendMenu(flag,MP_CAT_EDIT,GetResString(IDS_CAT_EDIT));
	menu.AppendMenu(flag,MP_CAT_REMOVE, GetResString(IDS_CAT_REMOVE));

	menu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);

	VERIFY( m_PrioMenu.DestroyMenu() );
	VERIFY( m_CatMenu.DestroyMenu() );
	VERIFY( menu.DestroyMenu() );

	*pResult = 0;
}

void CTransferWnd::OnLvnBegindrag(NMHDR *pNMHDR, LRESULT *pResult)
{
    int iSel = downloadlistctrl.GetSelectionMark();
	if (iSel==-1) return;
	if (((CtrlItem_Struct*)downloadlistctrl.GetItemData(iSel))->type != FILE_TYPE) return;
	
	m_bIsDragging = true;

	POINT pt;
	::GetCursorPos(&pt);

	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	m_nDragIndex = pNMLV->iItem;
	m_pDragImage = downloadlistctrl.CreateDragImage( downloadlistctrl.GetSelectionMark() ,&pt);
    m_pDragImage->BeginDrag( 0, CPoint(0,0) );
    m_pDragImage->DragEnter( GetDesktopWindow(), pNMLV->ptAction );
    SetCapture();
	m_nDropIndex = -1;

	*pResult = 0;
}

void CTransferWnd::OnMouseMove(UINT nFlags, CPoint point)
{
	if( !(nFlags & MK_LBUTTON) ) m_bIsDragging = false;

	if (m_bIsDragging){
		CPoint pt(point);           //get our current mouse coordinates
		ClientToScreen(&pt);        //convert to screen coordinates

		m_nDropIndex=GetTabUnderMouse(&pt);

                // [ionix] - Modified Categories
		if (m_nDropIndex>0 && thePrefs.GetCategory(m_nDropIndex)->viewfilters.care4all)	// not droppable
			m_dlTab.SetCurSel(-1);
		else
		m_dlTab.SetCurSel(m_nDropIndex);

		m_dlTab.Invalidate();
		
		::GetCursorPos(&pt);
		pt.y-=10;
		m_pDragImage->DragMove(pt); //move the drag image to those coordinates
	}
}

void CTransferWnd::OnLButtonUp(UINT nFlags, CPoint point)
{

	if (m_bIsDragging)
	{
		ReleaseCapture ();
		m_bIsDragging = false;
		m_pDragImage->DragLeave (GetDesktopWindow ());
		m_pDragImage->EndDrag ();
		delete m_pDragImage;
		
		if (m_nDropIndex>-1 && (downloadlistctrl.curTab==0 ||
				(downloadlistctrl.curTab>0 && m_nDropIndex!=downloadlistctrl.curTab) )) {

			CPartFile* file;

			// for multiselections
			CTypedPtrList <CPtrList,CPartFile*> selectedList; 
			POSITION pos = downloadlistctrl.GetFirstSelectedItemPosition();
			while(pos != NULL) 
			{ 
				int index = downloadlistctrl.GetNextSelectedItem(pos);
				if(index > -1 && (((CtrlItem_Struct*)downloadlistctrl.GetItemData(index))->type == FILE_TYPE))
					selectedList.AddTail( (CPartFile*)((CtrlItem_Struct*)downloadlistctrl.GetItemData(index))->value );
			}

			while (!selectedList.IsEmpty())
			{
				file = selectedList.GetHead();
				selectedList.RemoveHead();
				file->SetCategory(m_nDropIndex);
			}


			m_dlTab.SetCurSel(downloadlistctrl.curTab);
			//if (m_dlTab.GetCurSel()>0 || (thePrefs.GetAllcatType()==1 && m_dlTab.GetCurSel()==0) )
			downloadlistctrl.UpdateCurrentCategoryView();

			UpdateCatTabTitles();

		} else m_dlTab.SetCurSel(downloadlistctrl.curTab);
		downloadlistctrl.Invalidate();
	}
}

BOOL CTransferWnd::OnCommand(WPARAM wParam,LPARAM lParam ){ 

	// [ionix] - Modified Categories by khaos::categorymod+
	Category_Struct* curCat;
	curCat = thePrefs.GetCategory(rightclickindex);
	// [ionix] - Modified Categories by khaos::categorymod+

	switch (wParam){ 
		case MP_CAT_ADD: {
			m_nLastCatTT=-1;
			int newindex=AddCategory(_T("?"),thePrefs.GetIncomingDir(),_T(""),_T(""),false);
			CCatDialog dialog(newindex);
			dialog.DoModal();
			if (dialog.WasCancelled())
				thePrefs.RemoveCat(newindex);
			else {
				theApp.emuledlg->searchwnd->UpdateCatTabs();
				m_dlTab.InsertItem(newindex,thePrefs.GetCategory(newindex)->title);
				EditCatTabLabel(newindex,thePrefs.GetCategory(newindex)->title);
				thePrefs.SaveCats();
				VerifyCatTabSize();
			}
			break;
		}
		case MP_CAT_EDIT: {
			m_nLastCatTT=-1;
			CCatDialog dialog(rightclickindex);
			dialog.DoModal();

			CString csName;
			csName.Format(_T("%s"), thePrefs.GetCategory(rightclickindex)->title );
			EditCatTabLabel(rightclickindex,csName);
		
			theApp.emuledlg->searchwnd->UpdateCatTabs();
			theApp.emuledlg->transferwnd->downloadlistctrl.UpdateCurrentCategoryView();
			thePrefs.SaveCats();
			break;
		}
		case MP_CAT_REMOVE: {
			m_nLastCatTT=-1;
			bool toreload=( _tcsicmp(thePrefs.GetCatPath(rightclickindex),thePrefs.GetIncomingDir())!=0);
			theApp.downloadqueue->ResetCatParts(rightclickindex);
			thePrefs.RemoveCat(rightclickindex);
			m_dlTab.DeleteItem(rightclickindex);
			m_dlTab.SetCurSel(0);
			downloadlistctrl.ChangeCategory(0);
			thePrefs.SaveCats();
			//if (thePrefs.GetCatCount()==1) 
			//	thePrefs.GetCategory(0)->filter=0;
			//theApp.emuledlg->searchwnd->UpdateCatTabs();
			VerifyCatTabSize();
			if (toreload)
				theApp.sharedfiles->Reload();
			break;
		}
// By BadWolf
		case MP_HM_OPENINC:
			m_nLastCatTT=-1;
			ShellExecute(NULL, _T("open"),thePrefs.GetCatPath(rightclickindex),NULL, NULL, SW_SHOW); 
			break;
//END By BadWolf
		case MP_PRIOLOW:
            thePrefs.GetCategory(rightclickindex)->prio = PR_LOW;
			thePrefs.SaveCats();
			break;
		case MP_PRIONORMAL:
            thePrefs.GetCategory(rightclickindex)->prio = PR_NORMAL;
			thePrefs.SaveCats();
			break;
		case MP_PRIOHIGH:
            thePrefs.GetCategory(rightclickindex)->prio = PR_HIGH;
			thePrefs.SaveCats();
			break;

		case MP_PAUSE:
			theApp.downloadqueue->SetCatStatus(rightclickindex,MP_PAUSE);
			break;
		case MP_STOP :
				theApp.downloadqueue->SetCatStatus(rightclickindex,MP_STOP);
			break;
		case MP_CANCEL:
			if (AfxMessageBox(GetResString(IDS_Q_CANCELDL),MB_ICONQUESTION|MB_YESNO) == IDYES)
				theApp.downloadqueue->SetCatStatus(rightclickindex,MP_CANCEL);
			break;
		case MP_RESUME:
			theApp.downloadqueue->SetCatStatus(rightclickindex,MP_RESUME);
			break;
		case MP_RESUMENEXT:
			theApp.downloadqueue->StartNextFile(rightclickindex,false);
			break;

		case MP_DOWNLOAD_ALPHABETICAL: {
            BOOL newSetting = !thePrefs.GetCategory(rightclickindex)->downloadInAlphabeticalOrder;
            thePrefs.GetCategory(rightclickindex)->downloadInAlphabeticalOrder = newSetting;
			thePrefs.SaveCats();
            if(newSetting) {
                // any auto prio files will be set to normal now.
                theApp.downloadqueue->RemoveAutoPrioInCat(rightclickindex, PR_NORMAL);
            }

            break;
		}

		case IDC_UPLOAD_ICO:
			SwitchUploadList();
			break;
		//[ionix] Drop Menue Buttons start
		case IDC_TRANSFER_DROP_FULLQ: {
			DropAllFullQ();
			break;
		}
		case IDC_TRANSFER_DROP_NNS: {
			DropAllNNS();
			break;
		}
		case IDC_TRANSFER_DROP_TOO_MANY: {
			DropAllTooMany();
			break;
		}
		case IDC_TRANSFER_DROP_HIGH_QUEUE_SOURCES: {
			DropAllHighQueueSources();
			break;
		}
		//[ionix] Drop Menue Buttons End
		// Pawcio: CQV
		case IDC_UP_QUEUE: {
			ShowWnd2(wnd2Uploading);
			break;
		}
		case IDC_DOWN_QUEUE: {
			ShowWnd2(wnd2Downloading);
			break;
		}
		case IDC_WAIT_QUEUE: {
			ShowWnd2(wnd2OnQueue);
			break;
		}
		case IDC_CLIENT_QUEUE: {
			ShowWnd2(wnd2Clients);
			break;
		}
		// <--- Pawcio: CQV
		case IDC_QUEUE_REFRESH_BUTTON: {
			OnBnClickedQueueRefreshButton();
			break;
		}
		// [ionix] - Modified Categories (parts by khaos::categorymod+): Handle the new view filter menu.
		case MP_CAT_SET0:
		case MP_CAT_SET0+1:
		case MP_CAT_SET0+2: {
			curCat->viewfilters.nFromCats = wParam - MP_CAT_SET0;
			break;
		}						
		case MP_CAT_SET0+3: {
			curCat->viewfilters.care4all = curCat->viewfilters.care4all ? false : true;
			break;
		}
		case MP_CAT_SET0+4: {
			curCat->viewfilters.bComplete = curCat->viewfilters.bComplete ? false : true;
			break;
		}
		case MP_CAT_SET0+5: {
			curCat->viewfilters.bCompleting = curCat->viewfilters.bCompleting ? false : true;
			break;
		}
		case MP_CAT_SET0+6: {
			curCat->viewfilters.bTransferring = curCat->viewfilters.bTransferring ? false : true;
			break;
		}
		case MP_CAT_SET0+7: {
			curCat->viewfilters.bWaiting = curCat->viewfilters.bWaiting ? false : true;
			break;
		}
		case MP_CAT_SET0+8: {
			curCat->viewfilters.bPaused = curCat->viewfilters.bPaused ? false : true;
			break;
		}
		case MP_CAT_SET0+9: {
			curCat->viewfilters.bStopped = curCat->viewfilters.bStopped ? false : true;
			break;
		}
		case MP_CAT_SET0+10: {
			curCat->viewfilters.bHashing = curCat->viewfilters.bHashing ? false : true;
			break;
		}
		case MP_CAT_SET0+11: {
			curCat->viewfilters.bErrorUnknown = curCat->viewfilters.bErrorUnknown ? false : true;
			break;
		}
		case MP_CAT_SET0+12: {
			curCat->viewfilters.bVideo = curCat->viewfilters.bVideo ? false : true;
			break;
		}
		case MP_CAT_SET0+13: {
			curCat->viewfilters.bAudio = curCat->viewfilters.bAudio ? false : true;
			break;
		}
		case MP_CAT_SET0+14: {
			curCat->viewfilters.bArchives = curCat->viewfilters.bArchives ? false : true;
			break;
		}
		case MP_CAT_SET0+15: {
			curCat->viewfilters.bCDImages = curCat->viewfilters.bCDImages ? false : true;
			break;
		}
		case MP_CAT_SET0+16: {
			curCat->viewfilters.bDoc = curCat->viewfilters.bDoc ? false : true;
			break;
		}
 		case MP_CAT_SET0+17: {
			curCat->viewfilters.bImages = curCat->viewfilters.bImages ? false : true;
			break;
		}
 		case MP_CAT_SET0+18: {
			curCat->viewfilters.bProgram = curCat->viewfilters.bProgram ? false : true;
			break;
		}
		case MP_CAT_SET0+19: {
			curCat->viewfilters.bSuspendFilters = curCat->viewfilters.bSuspendFilters ? false : true;
			break;
		}
	}

	if (wParam >= MP_CAT_SET0 && wParam <= MP_CAT_SET0 + 18)
		// set to regexp but none is set for that category?
		if (wParam==MP_CAT_SET0+2 && thePrefs.GetCategory(m_isetcatmenu)->regexp.IsEmpty() ) {
			m_nLastCatTT=-1;
			CCatDialog dialog(rightclickindex);
			dialog.DoModal();

			// still no regexp?
			if (thePrefs.GetCategory(m_isetcatmenu)->regexp.IsEmpty()) {
				curCat->viewfilters.nFromCats =0;
			}

		}
		downloadlistctrl.ChangeCategory(m_dlTab.GetCurSel());	
		downloadlistctrl.UpdateCurrentCategoryView();
		EditCatTabLabel(m_isetcatmenu, thePrefs.GetCategory(m_isetcatmenu)->title);
		thePrefs.SaveCats();
	// [ionix] - Modified Categories (parts by khaos::categorymod+)

	return TRUE;
}

void CTransferWnd::UpdateCatTabTitles(bool force)
{
	CPoint pt;
	::GetCursorPos(&pt);
	if (!force && GetTabUnderMouse(&pt)!=-1)		// avoid cat tooltip jumping
		return;

	for (uint8 i=0;i<m_dlTab.GetItemCount();i++)
		EditCatTabLabel(i, thePrefs.GetCategory(i)->title);
}

void CTransferWnd::EditCatTabLabel(int index,CString newlabel)
{

	TCITEM tabitem;
	tabitem.mask = TCIF_PARAM;
	m_dlTab.GetItem(index,&tabitem);
	tabitem.mask = TCIF_TEXT;

	newlabel.Replace(_T("&"),_T("&&"));

        // [ionix] - Modified Categories by khaos::categorymod+
/*
	if (!index)
		newlabel.Empty();

	if (!index || (index && thePrefs.GetCatFilter(index)>0)) {

		if (index)
		newlabel.Append(_T(" (")) ;
		
		if (thePrefs.GetCatFilterNeg(index))
			newlabel.Append(_T("!"));			

		if (thePrefs.GetCatFilter(index)==18)
			newlabel.Append( _T("\"") + thePrefs.GetCategory(index)->regexp + _T("\"") );
		else
        	newlabel.Append( GetCatTitle(thePrefs.GetCatFilter(index)));

		if (index)
			newlabel.Append( _T(")") );
	}
*/
	if(thePrefs.CatExists(index))
		if(thePrefs.GetCategory(index)->viewfilters.nFromCats == 2)
			newlabel.Append( _T(" (\"") + thePrefs.GetCategory(index)->regexp + _T("\")") );
		//else
        	//newlabel.Append( _T(" (") + GetCatTitle(thePrefs.GetCategory(index)->viewfilters.nFromCats) + _T(")") );
        // [ionix] - Modified Categories by khaos::categorymod+

	int count,dwl;
	if (thePrefs.ShowCatTabInfos()) {
		CPartFile* cur_file;
		count=dwl=0;
		for (int i=0;i<theApp.downloadqueue->GetFileCount();i++) {
			cur_file=theApp.downloadqueue->GetFileByIndex(i);
			if (cur_file==0) continue;
			if (cur_file->CheckShowItemInGivenCat(index)) {
				if (cur_file->GetTransferringSrcCount()>0) ++dwl;
			}
		}
		CString title=newlabel;
		theApp.emuledlg->transferwnd->downloadlistctrl.GetCompleteDownloads(index, count);
		newlabel.Format(_T("%s %i/%i"),title,dwl,count); // ZZ:DownloadManager
	}

	tabitem.pszText = newlabel.LockBuffer();
	m_dlTab.SetItem(index,&tabitem);
	newlabel.UnlockBuffer();

	VerifyCatTabSize();
}

int CTransferWnd::AddCategory(CString newtitle,CString newincoming,CString newcomment, CString newautocat, bool addTab){
	Category_Struct* newcat=new Category_Struct;

	_stprintf(newcat->title,newtitle);
	newcat->prio=PR_NORMAL; // ZZ:DownloadManager
	_stprintf(newcat->incomingpath,newincoming);
	_stprintf(newcat->comment,newcomment);
	newcat->regexp.Empty();
	newcat->ac_regexpeval=false;
	newcat->autocat=newautocat;
    newcat->downloadInAlphabeticalOrder = FALSE; // ZZ:DownloadManager
	//newcat->filter=0;
	//newcat->filterNeg=false;
	newcat->viewfilters.care4all=false;

	// [ionix] - Modified Categories by khaos::categorymod+: Initialize View Filter Variables
	newcat->viewfilters.bArchives = true;
	newcat->viewfilters.bAudio = true;
	newcat->viewfilters.bComplete = true;
	newcat->viewfilters.bCompleting = true;
	newcat->viewfilters.bErrorUnknown = true;
	newcat->viewfilters.bHashing = true;
	newcat->viewfilters.bImages = true;
	newcat->viewfilters.bCDImages = true;
	newcat->viewfilters.bDoc = true;
	newcat->viewfilters.bProgram = true;
	newcat->viewfilters.bPaused = true;
	newcat->viewfilters.bStopped = true;
	newcat->viewfilters.bSuspendFilters = false;
	newcat->viewfilters.bTransferring = true;
	newcat->viewfilters.bVideo = true;
	newcat->viewfilters.bWaiting = true;
	// [ionix] - Modified Categories by khaos::categorymod+

	int index=thePrefs.AddCat(newcat);
	if (addTab) m_dlTab.InsertItem(index,newtitle);
	VerifyCatTabSize();
	
	return index;
}

int CTransferWnd::GetTabUnderMouse(CPoint* point) {

		TCHITTESTINFO hitinfo;
		CRect rect;
		m_dlTab.GetWindowRect(&rect);
		point->Offset(0-rect.left,0-rect.top);
		hitinfo.pt = *point;

		if( m_dlTab.GetItemRect( 0, &rect ) )
			if (hitinfo.pt.y< rect.top+30 && hitinfo.pt.y >rect.top-30)
				hitinfo.pt.y = rect.top;

		// Find the destination tab...
		unsigned int nTab = m_dlTab.HitTest( &hitinfo );

		if( hitinfo.flags != TCHT_NOWHERE )
			return nTab;
	else
		return -1;
}

void CTransferWnd::OnLvnKeydownDownloadlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	int iItem = downloadlistctrl.GetSelectionMark();
	if (iItem != -1)
	{
		bool bAltKey = GetAsyncKeyState(VK_MENU) < 0;
		int iAction = EXPAND_COLLAPSE;
		if (pLVKeyDow->wVKey==VK_ADD || (bAltKey && pLVKeyDow->wVKey==VK_RIGHT))
			iAction = EXPAND_ONLY;
		else if (pLVKeyDow->wVKey==VK_SUBTRACT || (bAltKey && pLVKeyDow->wVKey==VK_LEFT))
			iAction = COLLAPSE_ONLY;
		if (iAction < EXPAND_COLLAPSE)
			downloadlistctrl.ExpandCollapseItem(iItem, iAction, true);
	}
	*pResult = 0;
}

void CTransferWnd::UpdateTabToolTips(int tab)
{
	if (tab == -1)
	{
		for (int i = 0; i < m_tooltipCats.GetToolCount(); i++)
			m_tooltipCats.DelTool(&m_dlTab, i + 1);

		for (int i = 0; i < m_dlTab.GetItemCount(); i++)
		{
			CRect r;
			m_dlTab.GetItemRect(i, &r);
			VERIFY( m_tooltipCats.AddTool(&m_dlTab, GetTabStatistic(i), &r, i + 1) );
		}
	}
	else
	{
		CRect r;
		m_dlTab.GetItemRect(tab, &r);
		m_tooltipCats.DelTool(&m_dlTab, tab + 1);
		VERIFY( m_tooltipCats.AddTool(&m_dlTab, GetTabStatistic(tab), &r, tab + 1) );
	}
}

CString CTransferWnd::GetTabStatistic(uint8 tab)
{
	uint16 count, dwl, err, paus;
	count = dwl = err = paus = 0;
	float speed=0;
	uint64 size=0;
	uint64 trsize=0;
	uint64 disksize=0;
	for (int i = 0; i < theApp.downloadqueue->GetFileCount(); i++)
	{
		/*const*/ CPartFile* cur_file = theApp.downloadqueue->GetFileByIndex(i);
		if (cur_file == 0)
			continue;
		if (cur_file->CheckShowItemInGivenCat(tab))
		{
			count++;
			if (cur_file->GetTransferringSrcCount() > 0)
				dwl++;
			speed += cur_file->GetDatarate() / 1024.0F;
			size+=cur_file->GetFileSize();
			trsize+=cur_file->GetCompletedSize();
			disksize+=cur_file->GetRealFileSize();
			if (cur_file->GetStatus() == PS_ERROR)
				err++;
			if (cur_file->GetStatus() == PS_PAUSED)
				paus++;
		}
	}

	int total;
	int compl = theApp.emuledlg->transferwnd->downloadlistctrl.GetCompleteDownloads(tab, total);

// ZZ:DownloadManager -->
    CString prio;
    switch (thePrefs.GetCategory(tab)->prio)
	{
        case PR_LOW:
            prio = GetResString(IDS_PRIOLOW);
            break;

        case PR_HIGH:
            prio = GetResString(IDS_PRIOHIGH);
            break;

        default:
            prio = GetResString(IDS_PRIONORMAL);
            break;
    }
// ZZ:DownloadManager <--

	CString title;
	title.Format(_T("%s: %i\n\n%s: %i\n%s: %i\n%s: %i\n%s: %i\n\n%s: %s\n\n%s: %.1f %s\n%s: %s/%s\n%s%s"),
		GetResString(IDS_FILES), count+compl,
		GetResString(IDS_DOWNLOADING), dwl,
		GetResString(IDS_PAUSED) ,paus,
		GetResString(IDS_ERRORLIKE) ,err,
		GetResString(IDS_DL_TRANSFCOMPL) ,compl,
        GetResString(IDS_PRIORITY), prio,
		GetResString(IDS_DL_SPEED) ,speed,GetResString(IDS_KBYTESEC),


		GetResString(IDS_DL_SIZE),CastItoXBytes(trsize, false, false),CastItoXBytes(size, false, false),
		GetResString(IDS_ONDISK),CastItoXBytes(disksize, false, false));
	return title;
}


void CTransferWnd::OnDblclickDltab()
{
	POINT point;
	::GetCursorPos(&point);
	CPoint pt(point);
	int tab=GetTabUnderMouse(&pt);
	if (tab < 1)
		return;
	rightclickindex=tab;
	OnCommand(MP_CAT_EDIT,0);
}

void CTransferWnd::OnTabMovement(NMHDR *pNMHDR, LRESULT *pResult)
{
	UINT from=m_dlTab.GetLastMovementSource();
	UINT to=m_dlTab.GetLastMovementDestionation();

	if (from==0 || to==0 || from==to-1) return;

	// do the reorder
	
	// rearrange the cat-map
	if (!thePrefs.MoveCat(from,to)) return;

	// update partfile-stored assignment
	theApp.downloadqueue->MoveCat((uint8)from,(uint8)to);

	// move category of completed files
	downloadlistctrl.MoveCompletedfilesCat((uint8)from,(uint8)to);

	// of the tabcontrol itself
	m_dlTab.ReorderTab(from,to);

	UpdateCatTabTitles();
	theApp.emuledlg->searchwnd->UpdateCatTabs();

	if (to>from) --to;
	m_dlTab.SetCurSel(to);
	downloadlistctrl.ChangeCategory(to);
}

void CTransferWnd::VerifyCatTabSize()
{
	CRect rect;
	int size=0;
	int right;

	for (int i=0;i<m_dlTab.GetItemCount();i++) {
		m_dlTab.GetItemRect(i,&rect);
		size+= rect.Width();
	}
	size+=20;

	WINDOWPLACEMENT wpTabWinPos;

	downloadlistctrl.GetWindowPlacement(&wpTabWinPos);
	right=wpTabWinPos.rcNormalPosition.right;

	m_dlTab.GetWindowPlacement(&wpTabWinPos);
	if (wpTabWinPos.rcNormalPosition.right<0) return;

	wpTabWinPos.rcNormalPosition.right=right;
	int left=wpTabWinPos.rcNormalPosition.right-size;
	if (left<200) left=200;
	wpTabWinPos.rcNormalPosition.left=left;

	RemoveAnchor(m_dlTab);
	m_dlTab.SetWindowPlacement(&wpTabWinPos);
	AddAnchor(m_dlTab,TOP_RIGHT);
}

CString CTransferWnd::GetCatTitle(int catid)
{
	switch (catid) {
		case 0 : return GetResString(IDS_ALL);
		case 1 : return GetResString(IDS_ALLOTHERS);
		case 2 : return GetResString(IDS_STATUS_NOTCOMPLETED);
		case 3 : return GetResString(IDS_DL_TRANSFCOMPL);
		case 4 : return GetResString(IDS_WAITING);
		case 5 : return GetResString(IDS_DOWNLOADING);
		case 6 : return GetResString(IDS_ERRORLIKE);
		case 7 : return GetResString(IDS_PAUSED);
		case 8 : return GetResString(IDS_SEENCOMPL);
		case 10 : return GetResString(IDS_VIDEO);
		case 11 : return GetResString(IDS_AUDIO);
		case 12 : return GetResString(IDS_SEARCH_ARC);
		case 13 : return GetResString(IDS_SEARCH_CDIMG);

		case 14 : return GetResString(IDS_SEARCH_DOC);
		case 15 : return GetResString(IDS_SEARCH_PICS);
		case 16 : return GetResString(IDS_SEARCH_PRG);
//		case 18 : return GetResString(IDS_REGEXPRESSION);
	}
	return _T("?");
}

//[ionix] Drop Menue Buttons
void	CTransferWnd::DropAllFullQ(){
	downloadlistctrl.DropAllFullQ();
}
void	CTransferWnd::DropAllNNS(){
	downloadlistctrl.DropAllNNS();
}
void	CTransferWnd::DropAllTooMany(){
	downloadlistctrl.DropAllTooMany();
}
void	CTransferWnd::DropAllHighQueueSources(){
	downloadlistctrl.DropAllHighQueueSources();
}
//[ionix] Drop Menue Buttons end
// Pawcio: Mod Version
int CTransferWnd::Mod_Version_Sort_by_String   (const CUpDownClient *client1, const CUpDownClient *client2)
{	
		// modified by sivka [Maella: -Support for tag ET_MOD_VERSION 0x55-]
		if(client1->GetClientSoft() == client2->GetClientSoft())
			if(client2->GetVersion() == client1->GetVersion() && client1->GetClientSoft() == SO_EMULE){				
				return _tcscmp(client2->GetClientModVer(), client1->GetClientModVer());
			}
			else {
				return client2->GetVersion() - client1->GetVersion();
			}
		else
			return client1->GetClientSoft() - client2->GetClientSoft();
		// Maella end
}

//>>> ProgressBars  
void CALLBACK CTransferWnd::ProgessBarTimer(HWND hwnd, UINT uiMsg, UINT idEvent, DWORD dwTime)  
{  
     if(!theApp.emuledlg || !theApp.emuledlg->transferwnd->IsWindowVisible())  
          return;  
     theApp.emuledlg->transferwnd->m_pCPUBar.SetPos(GetCpuUsage(theApp.m_pszExeName));  
     theApp.emuledlg->transferwnd->m_pRAMBar.SetPos(theApp.sysinfo->GetProcessMemoryUsage()/1024.0F);  
}  

void CTransferWnd::ShowProgressBars()  
{  
	if(m_hTimer)  
	{  
		if (thePrefs.GetVerbose())  
			DebugLogError(true,_T("ProgressBars: m_hTimer already exists"));    
	}  
	else  
	{  
		m_pRAMBar.ShowWindow(SW_SHOW);  
		m_pCPUBar.ShowWindow(SW_SHOW);  
		GetDlgItem(IDC_RAMTITLE)->ShowWindow(SW_SHOW);  
		GetDlgItem(IDC_CPUTITLE)->ShowWindow(SW_SHOW);  

		//Added it here as we have to create everything first  
		AddAnchor(IDC_RAMTITLE, BOTTOM_LEFT, BOTTOM_LEFT);   
		AddAnchor(m_pRAMBar, BOTTOM_LEFT, BOTTOM_CENTER); //allow half of screensize  
		AddAnchor(IDC_CPUTITLE, BOTTOM_CENTER, BOTTOM_CENTER);        
		AddAnchor(m_pCPUBar, BOTTOM_CENTER, BOTTOM_RIGHT); //other half of screensize

		VERIFY( (m_hTimer = ::SetTimer(NULL, NULL, 500, ProgessBarTimer)) != NULL );    
		if (thePrefs.GetVerbose() && !m_hTimer)    
			DebugLogError(true,_T("Failed to create 'ProgressBar' timer - %s"), GetErrorMessage(GetLastError()));    

		//ChangeLayout(true); - moved to PPgBobo3.cpp
	}  
}  

void CTransferWnd::HideProgressBars()  
{  
	if (m_hTimer)    
	{    
		::KillTimer(NULL, m_hTimer);    
		m_hTimer = 0;    
	}    

	m_pRAMBar.ShowWindow(SW_HIDE);  
	m_pCPUBar.ShowWindow(SW_HIDE);  
	GetDlgItem(IDC_RAMTITLE)->ShowWindow(SW_HIDE);  
	GetDlgItem(IDC_CPUTITLE)->ShowWindow(SW_HIDE);  

	RemoveAnchor(IDC_RAMTITLE);   
	RemoveAnchor(m_pRAMBar);
	RemoveAnchor(IDC_CPUTITLE);        
	RemoveAnchor(m_pCPUBar);

	//ChangeLayout(false); - moved to PPgBobo3.cpp
}

void CTransferWnd::ChangeLayout(bool ProgressBars)
{
	int value = ProgressBars?15:0;

	CRect rcDown,rcW,rcSpl;
	GetWindowRect(rcW);
	ScreenToClient(rcW);

	GetDlgItem(IDC_UPLOADLIST)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.bottom=rcW.bottom-20-value;
	uploadlistctrl.MoveWindow(rcDown);

	//Pawcio: BC
	GetDlgItem(IDC_RESERVEDLIST)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.bottom=rcW.bottom-20-value;
	reservedlistctrl.MoveWindow(rcDown);
	//Pawcio: BC

	// Stormit: DTW
	GetDlgItem(IDC_DOWNLOADCLIENTS)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.bottom=rcW.bottom-20-value;
	downloadclientsctrl.MoveWindow(rcDown);
	// <--- Stormit: DTW

	GetDlgItem(IDC_QUEUELIST)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.bottom=rcW.bottom-20-value;
	queuelistctrl.MoveWindow(rcDown);

	GetDlgItem(IDC_CLIENTLIST)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.bottom=rcW.bottom-20-value;
	clientlistctrl.MoveWindow(rcDown);

	RemoveAnchor(IDC_QUEUE_REFRESH_BUTTON);   
	RemoveAnchor(IDC_TSTATIC1);
	RemoveAnchor(IDC_QUEUECOUNT);

	GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.top=rcW.bottom-19-value;
	rcDown.bottom=rcW.bottom-3-value;
	GetDlgItem(IDC_QUEUE_REFRESH_BUTTON)->MoveWindow(rcDown);

	GetDlgItem(IDC_TSTATIC1)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.top=rcW.bottom-18-value;
	rcDown.bottom=rcW.bottom-5-value;
	GetDlgItem(IDC_TSTATIC1)->MoveWindow(rcDown);

	GetDlgItem(IDC_QUEUECOUNT)->GetWindowRect(rcDown);
	ScreenToClient(rcDown);
	rcDown.top=rcW.bottom-18-value;
	rcDown.bottom=rcW.bottom-5-value;
	GetDlgItem(IDC_QUEUECOUNT)->MoveWindow(rcDown);

	AddAnchor(IDC_QUEUECOUNT,BOTTOM_LEFT);
	AddAnchor(IDC_TSTATIC1,BOTTOM_LEFT);
	AddAnchor(IDC_QUEUE_REFRESH_BUTTON, BOTTOM_RIGHT);
}
//<<< ProgressBars